#include <16f876a.h>
#fuses HS, NOWDT, PUT, NOPROTECT, NOLVP, NOBROWNOUT, NOCPD, NOWRT
#use delay(clock = 20000000)
#use fast_io(A)
#use fast_io(B)
#use fast_io(C)
#include "pin_def.c"
#use RS232(BAUD=57600, XMIT=SERIAL_OUT_PIN,RCV = SERIAL_IN_PIN,PARITY=N, BITS=8,ERRORS)
#define HIGH	1
#define LOW		0
#include "ps2pad_lib.c"
//ϐ錾
int tx_data_buf[18+3];
int tx_flag = 0;
//vg^Cv錾
void init_tx_buffer();
void main(){
	int i;
	//|[g̏
	output_a(0);
	output_b(0);
	output_c(0);
	//TRIS̐ݒ
	set_tris_a(DEF_TRISA);
	set_tris_b(DEF_TRISB);
	set_tris_c(DEF_TRISC);
	//ϐ̏
	tx_flag = 0;
	for(i = 0;i < 21;i++){
		tx_data_buf[i] = 0;
	}
	//PS2Cȕ
	ps2pad_lib_init();
	//Mobt@̏
	init_tx_buffer();

	output_high(SERIAL_OUT_PIN);
	delay_ms(100);
	set_rtcc(0);
	setup_counters(RTCC_INTERNAL, RTCC_DIV_64);
	enable_interrupts(INT_RTCC);
	enable_interrupts(GLOBAL);
	while(TRUE){
		if(tx_flag){
			ps2pad_rx();
			for(i = 0;i < 21;i++){
				putc(tx_data_buf[i]);
			}
			tx_flag = 0;
			delay_ms(1);
		}
	}
}
#INT_TIMER0
void timer0_int(){
	static int div = 0;
	if(div == 5){
		tx_flag = 1;
		div = 0;
	}
	div++;
}
void ps2pad_event_handler(int event){
	int i;
	int check_sum;
	switch(event){
		case PAD_EVENT_LIB_INITED:
			break;
		case PAD_EVENT_CONNECTION_ERROR:
			init_tx_buffer();
			check_sum = 0;
			for(i = 0;i < 20;i++){
				check_sum += tx_data_buf[i];
			}
			tx_data_buf[20] = check_sum;
			output_low(YELLOW_LED_PIN);
			output_high(RED_LED_PIN);
			output_low(GREEN_LED_PIN);
			break;
		case PAD_EVENT_RECEIVED_PAD_DATA:
			tx_data_buf[0] = 0b11110000;
			tx_data_buf[1] = 0b10101010;
			check_sum = tx_data_buf[0] + tx_data_buf[1];
			for(i = 2;i < 20;i++){
				tx_data_buf[i] = pad_data[i+1];
				check_sum += pad_data[i+1];
			}
			tx_data_buf[20] = check_sum;
			output_high(GREEN_LED_PIN);
			output_high(YELLOW_LED_PIN);
			output_low(RED_LED_PIN);
			break;
	}
}
void init_tx_buffer(){
    tx_data_buf[0] = 0b11110000;
    tx_data_buf[1] = 0b01010101;
    tx_data_buf[2] = 255;//{^1
    tx_data_buf[3] = 255;//{^2
    tx_data_buf[4] = 128;//RXeBbNE
    tx_data_buf[5] = 128;//RXeBbN㉺
    tx_data_buf[6] = 128;//LXeBbNE
    tx_data_buf[7] = 128;//LXeBbN㉺
    tx_data_buf[8] = 0;//ȍ~{^
    tx_data_buf[9] = 0;
    tx_data_buf[10] = 0;
    tx_data_buf[11] = 0;
    tx_data_buf[12] = 0;
    tx_data_buf[13] = 0;
    tx_data_buf[14] = 0;
    tx_data_buf[15] = 0;
    tx_data_buf[16] = 0;
    tx_data_buf[17] = 0;
    tx_data_buf[18] = 0;
    tx_data_buf[19] = 0;//{^I
}

